=== modified file 'bzrlib/transport/http/__init__.py'
--- bzrlib/transport/http/__init__.py	2006-09-15 21:40:16 +0000
+++ bzrlib/transport/http/__init__.py	2006-09-17 08:10:38 +0000
@@ -45,6 +45,10 @@
 from bzrlib.ui import ui_factory
 
 
+# TODO: This is not used anymore by HttpTransport_urllib
+# (extracting the auth info and prompting the user for a password
+# have been split), only the tests still use it. It should be
+# deleted and the tests rewritten ASAP to stay in sync.
 def extract_auth(url, password_manager):
     """Extract auth parameters from am HTTP/HTTPS url and add them to the given
     password manager.  Return the url, minus those auth parameters (which

=== modified file 'bzrlib/transport/http/_urllib.py'
--- bzrlib/transport/http/_urllib.py	2006-09-16 14:46:46 +0000
+++ bzrlib/transport/http/_urllib.py	2006-09-17 08:10:38 +0000
@@ -32,7 +32,7 @@
 from bzrlib.transport import register_urlparse_netloc_protocol
 from bzrlib.transport.http import (HttpTransportBase,
                                    HttpServer)
-# TODO: handle_response should integrated into the _urllib2_wrappers
+# TODO: handle_response should be integrated into the _urllib2_wrappers
 from bzrlib.transport.http.response import handle_response
 from bzrlib.transport.http._urllib2_wrappers import (
     Opener,
@@ -46,34 +46,22 @@
 class HttpTransport_urllib(HttpTransportBase):
     """Python urllib transport for http and https."""
 
-    # In order to debug we have to issue our traces in syc with
+    # In order to debug we have to issue our traces in sync with
     # httplib, which use print :(
     _debuglevel = 0
     
-    # TODO: jam 20060915 Rather than having a class-wide opener class
-    #       consider having a class-wide instance.
     _opener_class = Opener
 
     def __init__(self, base, from_transport=None):
         """Set the base path where files will be stored."""
         super(HttpTransport_urllib, self).__init__(base)
         if from_transport is not None:
-            # Tracing transport creations that use cloning process
-            # mutter('Cloning HttpTransport_urllib '
-            #       + 'for base : [%s], from base [%s]' % (base,
-            #                                              from_transport.base))
-            # import traceback
-            # mutter(''.join(traceback.format_stack()))
             self._accept_ranges = from_transport._accept_ranges
             self._connection = from_transport._connection
             self._user = from_transport._user
             self._password = from_transport._password
             self._opener = from_transport._opener
         else:
-            # Tracing transport creations that avoid cloning process
-            # mutter('Creating new HttpTransport_urllib for base : [%s]' % base)
-            # import traceback
-            # mutter(''.join(traceback.format_stack()))
             self._accept_ranges = True
             self._connection = None
             self._user = None
@@ -90,11 +78,12 @@
             realm = None
             host = request.get_host()
             password_manager = self._opener.password_manager
+            # Query the password manager first
             user, password = password_manager.find_user_password(None, host)
             if user == request.user and password is not None:
                 request.password = password
             else:
-                # Ask the user
+                # Ask the user if we MUST
                 http_pass = 'HTTP %(user)s@%(host)s password'
                 request.password = ui.ui_factory.get_password(prompt=http_pass,
                                                               user=request.user,

=== modified file 'bzrlib/transport/http/_urllib2_wrappers.py'
--- bzrlib/transport/http/_urllib2_wrappers.py	2006-09-16 14:46:46 +0000
+++ bzrlib/transport/http/_urllib2_wrappers.py	2006-09-17 08:10:38 +0000
@@ -37,11 +37,8 @@
 
 DEBUG = 0
 
-# TODO: Handle the user and password cleanly: do not force the
-# user to provide them in the url (at least for the
-# password). Have a look at the password_manager classes. Tip: it
-# may be possible to share the password_manager between across
-# all transports by prefixing the relm by the protocol used
+# TODO: It may be possible to share the password_manager across
+# all transports by prefixing the realm by the protocol used
 # (especially if other protocols do not use realms). See
 # PasswordManager below.
 
@@ -65,6 +62,7 @@
 from bzrlib.errors import (
     BzrError,
     ConnectionError,
+    InvalidHttpResponse,
     NoSuchFile,
     )
 
@@ -202,25 +200,13 @@
 
 # The urlib2.xxxAuthHandler handle the authentification of the
 # requests, to do that, they need an urllib2 PasswordManager *at
-# build time*.
-
-# We want to associate such PasswordManager objects to the
-# connection, so that they can be reused (otherwise we will have
-# to prompt the user for its password at each connection).
-
-# TODO: Is there a way to share the password manager with other
-# protocols ? By prefixing th realm with the protocol ? A
-# different password for the same user may be required on the
-# same host for different protocol/host/directories combination.
+# build time*. We also need one to reuse the passwords already
+# typed by the user.
 class PasswordManager(urllib2.HTTPPasswordMgrWithDefaultRealm):
 
     def __init__(self):
         urllib2.HTTPPasswordMgrWithDefaultRealm.__init__(self)
 
-    # TODO: jam 20060915 This manager should implement find_user_password
-    #       so that even if we don't supply username in the url, if the
-    #       site requests a password we prompt the user for one.
-
 
 class ConnectionHandler(urllib2.BaseHandler):
     """Provides connection-sharing by pre-processing requests.
@@ -233,20 +219,6 @@
     """
 
     handler_order = 1000 # after all pre-processings
-    _connection_of = {} # map connections by host
-
-    # TODO: We don't want a global cache that can interact badly
-    # with the test suite, but being able to share connections on
-    # the same (host IP, port) combination can be good even
-    # inside a single tranport (some redirections can benefit
-    # from it, bazaar-ng.org and bazaar-vcs.org are two virtual
-    # hosts on the same IP for example). So we may activate the
-    # cache as currently it is used inside one Transport at a
-    # time.
-    # jam 20060915: I think most of this get_key stuff can be removed
-    #               since we now properly share the connection between
-    #               clones of the same Transport.
-    _cache_activated = False
 
     def get_key(self, connection):
         """Returns the key for the connection in the cache"""
@@ -257,17 +229,8 @@
         if not host:
             raise urllib2.URLError('no host given')
 
-        # We create a connection (but it will not connect yet) to
-        # be able to get host and take default port into account
-        # (request don't do that) to avoid having different
-        # connections for http://host and http://host:80
+        # We create a connection (but it will not connect yet)
         connection = http_connection_class(host)
-        if self._cache_activated:
-            key = self.get_key(connection)
-            if key not in self._connection_of:
-                self._connection_of[key] = connection
-            else:
-                connection = self._connection_of[key]
 
         return connection
 
@@ -289,12 +252,6 @@
             # Create a new one
             connection = self.create_connection(request, http_connection_class)
             request.connection = connection
-        else:
-            if self._cache_activated:
-                # Capture the precioussss
-                key = self.get_key(connection)
-                if key not in self._connection_of:
-                    self._connection_of[key] = connection
 
         # All connections will pass here, propagate debug level
         connection.set_debuglevel(DEBUG)
@@ -441,7 +398,7 @@
 #
 #        # When we get rid of addinfourl, we must ensure that bzr
 #        # always use titled headers and that any header received
-#        # from server is also titled
+#        # from server is also titled.
 #
 #        headers = {}
 #        for header, value in (response.getheaders()):
@@ -625,9 +582,9 @@
                              extra=HTTPError(req.get_full_url(), code, msg,
                                              hdrs, fp))
         else:
-            raise InvalidHttpResponse(url,
+            raise InvalidHttpResponse(req.get_full_url(),
                                       'Unable to handle http code %d: %s'
-                                      % (response.code, response.reason))
+                                      % (code, msg))
 
 class Opener(object):
     """A wrapper around urllib2.build_opener
@@ -636,21 +593,11 @@
     """
     # TODO: Provides hooks for daugther classes.
 
-    # This is a global password manager object, intended to be shared
-    # by all instances of Opener. It is global so that users don't get
-    # prompted for their passwords more than once.
-    # TODO: jam 20060915 Consider making it only exist as long as the Opener 
-    #       is alive, or possibly as long as a living Transport group.
-    #       Consider a long-running gui: it may be better to prompt the
-    #       user for the password from time to time, rather than caching
-    #       the password indefinitely. At a minimum, the GUI should
-    #       be able to set policy.
-    password_manager = PasswordManager()
-
     def __init__(self,
                  connection=ConnectionHandler,
                  redirect=HTTPRedirectHandler,
                  error=HTTPErrorProcessor,):
+        self.password_manager = PasswordManager()
         # TODO: Implements the necessary wrappers for the handlers
         # commented out below
         self._opener = urllib2.build_opener( \
@@ -666,6 +613,9 @@
             )
         self.open = self._opener.open
         if DEBUG > 0:
+            # When dealing with handler order, it's easy to mess
+            # things up, the following will help understand which
+            # handler is used, when and for what.
             import pprint
             pprint.pprint(self._opener.__dict__)
 

